    /*
     * gmapv3.js
     *
     * this file's encoding is UTF-8
     *
     * Google Maps3 is required.
     *
     */

/**

   please define following functions in the JSP file which use
   this JavaScript in cases it needs


    // set point into textareas
    //
    // latTagName - name of input tag which holds latitude
    // lngTagName - name of input tag which holds longitude
    // point      - google.maps.LatLng
    //
    function setLatLng(point) {
        setValue2Tag("geoname_p_002flat", point.lat());
        setValue2Tag("geoname_p_002flng", point.lng());
    }

    // get point from element
    function getLatLng() {
        if (! isNaN(parseFloat(getValueFrom("geoname_p_002flat")))
           &&  ! isNaN(parseFloat(getValueFrom("geoname_p_002flng")))) {
            return new google.maps.LatLng(
                getValueFrom("geoname_p_002flat"),
                getValueFrom("geoname_p_002flng"));
        }
        throw "failed to get lat or lng";
    }


    // set latlng query condition
    //
    // llPoints - a list which has 2 google.maps.LatLng instances as members
    //
    function setLatLngQuery(llPoints) {
        setValue2Tag("geoname_cp_002flat1jshparam",
            Math.min(llPoints[0].lat(),llPoints[1].lat()));
        setValue2Tag("geoname_cp_002flat2jshparam",
            Math.max(llPoints[0].lat(),llPoints[1].lat()));
        setValue2Tag("geoname_cp_002flng1jshparam",
            Math.min(llPoints[0].lng(),llPoints[1].lng()));
        setValue2Tag("geoname_cp_002flng2jshparam",
            Math.max(llPoints[0].lng(),llPoints[1].lng()));
    }

    // get latlng query condition
    function getLatLngQuery() {
        if (
            ! isNaN(parseFloat(getValueFrom("geoname_cp_002flat1jshparam")))
            && ! isNaN(parseFloat(getValueFrom("geoname_cp_002flat2jshparam")))
            && ! isNaN(parseFloat(getValueFrom("geoname_cp_002flon1jshparam")))
            && ! isNaN(parseFloat(getValueFrom("geoname_cp_002flon2jshparam")))
        ) {
            return [
                new google.maps.LatLng(
                    getValueFrom("geoname_cp_002flat1jshparam"),
                    getValueFrom("geoname_cp_002flon1jshparam")),
                new google.maps.LatLng(
                    getValueFrom("geoname_cp_002flat2jshparam"),
                    getValueFrom("geoname_cp_002flon2jshparam"))
            ];
        }
        throw "failed to get lat1, lat2, lon1, or lon2";
    }


    // set zoom value into element
    // zoom    - value of zoom
    function setZoom(zoom) {
        setValue2Tag("geoname_p_002fscale", zoom);
    }

    function getZoom() {
        if (! isNaN(parseFloat(getValueFrom("geoname_p_002fscale")))) {
            return getValueFrom("geoname_p_002fscale");
        }
        throw "failed to get zoom";
    }

    function setRadius(radius) {
        setValue2Tag("geoname_p_002fradius", radius);
    }

    function getRadius() {
        if (! isNaN(parseFloat(getValueFrom("geoname_p_002fradius")))) {
            return getValueFrom("geoname_p_002fradius");
        }
        throw "failed to get radius";
    }

    function setMBR(pntList) {
        if (pntList == null || pntList.length != 2) {
            throw("pntList must be an array with 2 elems");
        }
        setValue2Tag("geoname_p_002fmbr", pntList[0].toString() + "-" + pntList[1].toString());
    }

    function getMBR() {
        return parseMBR(getValueFromId("geoname_p_002fmbr"));
    }


*/
    /**
     * get GMap instance
     */
    function getGMapInstance(elem, styles) {
      var mapOptions = {
        "center": new google.maps.LatLng(0, 0),
        "mapTypeId": google.maps.MapTypeId.ROADMAP,
        "gestureHandling": "greedy",
      };
      if (styles) {
        mapOptions.styles = styles;
      }
      return new google.maps.Map(elem, mapOptions);
    }

    /**
     * Mode
     */
    function Mode () {
    }
    Mode.prototype.map = null;
    Mode.prototype.listeners = [];
    Mode.prototype.addListener = function (listener) {
        this.listeners = this.listeners.concat(listener);
    }
    Mode.prototype.overlays = new Object();
    Mode.prototype.addOverlay = function (name, overlay) {
        this.overlays[name] = overlay;
        overlay.setMap(this.map);
    }
    Mode.prototype.getOverlay = function (name) {
        return this.overlays[name];
    }
    Mode.prototype.removeOverlay = function (name) {
        if (this.overlays[name] != null) {
            this.overlays[name].setMap(null);
        }
        this.overlays[name] = null;
    }
    Mode.prototype.modeName = null;
    Mode.prototype.getModeName = function () {
        return this.modeName;
    }
    Mode.prototype.tearDown = function () {
        for (name in this.overlays) {
            this.overlays[name].setMap(null);
        }
        for (listener in this.listeners) {
            google.maps.event.removeListener(this.listeners[listener]);
        }
    }
    Mode.prototype.zoom = 0;
    Mode.prototype.setZoom = function (zoom) {
        if (isNaN(zoom)) {
            throw "Mode.prototype.setZoom: zoom is not a number:" + zoom;
        }
        this.zoom = zoom;
    }
    Mode.prototype.control = null;
    Mode.prototype.setControl = function (control) {
        this.control = control;
    }

    Mode.prototype.markerColor = "";
    Mode.prototype.setMarkerColor = function(color) {
        this.markerColor = color;
    }

    Mode.prototype.markerUrl = "";
    Mode.prototype.setMarkerUrl = function(url) {
        this.markerUrl = url;
    }

    Mode.prototype.markerLabel = "";
    Mode.prototype.setMarkerLabel = function(label) {
        this.markerLabel = label;
    }

    /**
     * ModeManager
     */
    function ModeManager() {
    }

    ModeManager.defaultMode = null;
    ModeManager.setDefaultMode = function(mode) {
       ModeManager.defaultMode = mode;
    }
    ModeManager.currentMode = null;
    ModeManager.changeMode = function(mode) {
        if (ModeManager.currentMode) {
            if (ModeManager.currentMode.control) {
                ModeManager.currentMode.control.turnOff();
            }
            ModeManager.currentMode.tearDown();
        }
        ModeManager.currentMode = mode;
        if (ModeManager.currentMode) {
            if (ModeManager.currentMode.control) {
                ModeManager.currentMode.control.turnOn();
            }
            ModeManager.currentMode.setUp();
        }
    }
    ModeManager.exitMode = function () {
        ModeManager.changeMode(ModeManager.defaultMode);
    }
    ModeManager.init = function () {
        ModeManager.changeMode(ModeManager.defaultMode);
    }

    // MyCustomControl is written with a reference from
    // http://www.google.com/apis/maps/documentation/#Custom_Controls

    function MyCustomControl(title, listener, mode) {
        this.buttonTitle = title;
        this.listenerFunc = listener;
        this.mode = mode;
    }
    MyCustomControl.prototype.mode = null;
    MyCustomControl.prototype.button = null;
    MyCustomControl.prototype.buttonTitle = null;
    MyCustomControl.prototype.listenerFunc = null;

    MyCustomControl.prototype.initialize = function(map) {

        if (this.mode) {
            this.mode.control = this;
        }

        var container = document.createElement("div");
        var myDiv = document.createElement("div");
        this.button = myDiv;
        this.setButtonStyle_(myDiv);
        container.appendChild(myDiv);
        myDiv.appendChild(document.createTextNode(this.buttonTitle));
        google.maps.event.addDomListener(myDiv, "click", this.listenerFunc);
        map.controls[google.maps.ControlPosition.RIGHT].push(container);
        return container;
    }
    MyCustomControl.prototype.setListener = function(listener) {
        this.listenerFunc = listener;
    }
    MyCustomControl.prototype.turnOn = function () {
        this.button.style.backgroundColor = "gray";
    }
    MyCustomControl.prototype.turnOff = function () {
        this.button.style.backgroundColor = "white";
    }
    // check if these 2 definition below overrides others
    MyCustomControl.prototype.defaultPosition = null;

    MyCustomControl.prototype.setButtonStyle_ = function(button) {
//        button.style.textDecoration = "underline";
//        button.style.color = "#0000cc";
        button.style.backgroundColor = "white";
        button.style.font = "small Arial";
//        button.style.font = "9px Arial";
//        button.style.fontSize = "1px";
        button.style.border = "1px solid black";
        button.style.padding = "2px";
        button.style.marginBottom = "3px";
        button.style.textAlign = "center";
        button.style.width = "3em";
        button.style.cursor = "pointer";
    }


    function MyCustomImgControl(/* url */ imgOn, /* url */ imgOff, /* int */ imgWidth, /* int */ imgHeight, /* function */ listener, /* Mode */ mode) {
        this.imgOn = imgOn;
        this.imgOff = imgOff;
        this.imgWidth = imgWidth;
        this.imgHeight = imgHeight;
        this.listenerFunc = listener;
        this.mode = mode;
    }
    MyCustomImgControl.prototype = new Object();
    MyCustomImgControl.prototype.mode = null;
    MyCustomImgControl.prototype.button = null;
    MyCustomImgControl.prototype.imgOn = null;
    MyCustomImgControl.prototype.imgOff = null;
    MyCustomImgControl.prototype.imgWidth = null;
    MyCustomImgControl.prototype.imgHeight = null;
    MyCustomImgControl.prototype.listenerFunc = null;

    MyCustomImgControl.prototype.initialize = function(map) {
        if (this.mode) {
            this.mode.control = this;
        }

        var container = document.createElement("div");
        container.style.mozUserSelect="none";
        container.style.khtmlUserSelect="none";
        container.style.webkitUserSelect="none";
        container.style.userSelect="none";
        
        container.style.margin='5px';
        container.style.border='0px';
        container.style.padding='0px';
        if (navigator.userAgent.toLowerCase().indexOf("msie") != -1) {
            container.style.marginTop='2px';
            container.style.marginBottom='2px';
            container.style.marginLeft='10px';
            container.style.marginRight='10px';
        }
        this.button = document.createElement("img");
        this.button.style.width = this.imgWidth + "px";
        this.button.style.height = this.imgHeight + "px";
        this.button.style.margin = '0px';
        this.button.style.border = '0px';
        this.button.style.padding = '0px';
        this.button["src"] = this.imgOff;
        this.button.style.cursor = "pointer";

        this.button.style.mozUserSelect="none";
        this.button.style.khtmlUserSelect="none";
        this.button.style.webkitUserSelect="none";
        this.button.style.userSelect="none";

        container.appendChild(this.button);
        google.maps.event.addDomListener(this.button, "click", 
            this.listenerFunc);
        map.controls[google.maps.ControlPosition.RIGHT].push(container);
        return container;
    }
    MyCustomImgControl.prototype.setListener = function(listener) {
        this.listenerFunc = listener;
    }
    MyCustomImgControl.prototype.turnOn = function () {
        this.button["src"] = this.imgOn;
    }
    MyCustomImgControl.prototype.turnOff = function () {
        this.button["src"] = this.imgOff;
    }
    // check if these 2 definition below overrides others
    MyCustomImgControl.prototype.defaultPosition = null;

    /**
     * SliderControl
     */
    function SliderControl(sliderValue) {
        this.sliderValue = sliderValue || 0;
    }
    SliderControl.prototype = new Object();
    SliderControl.prototype.grabknob = false;
    SliderControl.prototype.MINX = 3;
    SliderControl.prototype.MAXX = 54;

    SliderControl.prototype.getSliderValue = function() {
        return this.sliderValue;
    }
    SliderControl.prototype.setSliderValue = function(value) {
        if (value) {
            this.sliderValue = value;
            if (this.knobImg) {
                this.knobImg.style.left = ((this.MAXX - this.MINX) *
                    this.sliderValue + this.MINX) + "px";
            }
        }
    }
    SliderControl.prototype.initialize = function(map) {
        var container = document.createElement("div");
        this.setContainerStyle_(container);
        var sliderImg = document.createElement("img");
        sliderImg["src"] = "img/gmap_slider.gif";
        sliderImg.style.width = container.style.width;
        sliderImg.style.height = container.style.height;
        sliderImg.style.mozUserSelect="none";
        sliderImg.style.khtmlUserSelect="none";
        sliderImg.style.webkitUserSelect="none";
        sliderImg.style.userSelect="none";

        container.appendChild(sliderImg);

        container.style.mozUserSelect="none";
        container.style.khtmlUserSelect="none";
        container.style.webkitUserSelect="none";
        container.style.userSelect="none";

        var knobImg = document.createElement("img");
        knobImg["src"] = "img/gmap_knob.gif";
        knobImg.style.position = "absolute";
        knobImg.style.top = "4px";
        knobImg.style.left = ((this.MAXX - this.MINX) *
            this.sliderValue + this.MINX) + "px";
        knobImg.style.width = "10px";
        knobImg.style.height = "12px";
        knobImg.style.cursor = "pointer";
        container.appendChild(knobImg);
        var self = this;

        knobImg.onmousedown = function(event) {
            self.grabknob = true;
            self.dragKnob(event);
            return false;
        }
        knobImg.onmouseup = function(event) {
            self.grabknob = false;
            return false;
        }
        knobImg.onmouseout = function(event) {
            if (self.grabknob == true) {
                self.dragKnob(event);
            }
            return false;
        }

        container.onmouseup = function(event) {
            self.grabknob = false;
            return false;
        }
        container.onmousemove = function(event) {
            if (self.grabknob == true) {
                self.dragKnob(event);
            }
            return false;
        }
        container.onmouseover = function(event) {
            if (self.grabknob == true) {
                self.dragKnob(event);
            }
            return false;
        }
        container.onmouseout = function(event) {
            var offset = self.getOffset(event, container);
            if (offset.y < 0 || 
                offset.y > self.getPxValue(container.style.height)) {
                self.grabknob = false;
            }
            if (self.grabknob == true) {
                self.dragKnob(event);
            }
            return false;
        }

        this.knobImg = knobImg;
        this.container = container;

        map.controls[google.maps.ControlPosition.RIGHT].push(container);

        return container;
    }
    SliderControl.prototype.sliderListener = null;
    SliderControl.prototype.setSliderListener = function(listener) {
        this.sliderListener = listener;
    }

    SliderControl.prototype.getPxValue = function(value) {
        value = value + "";
        if (value.indexOf("px") >= 0) {
            return parseInt(value.substring(0,value.indexOf("px")));
        }
        return parseInt(value);
    }

    SliderControl.prototype.dragKnob = function(event) {
         var offset = this.getOffset(event, this.container);
         var x = offset.x;
         x = x - 4;
         if (x < this.MINX) {
            x = this.MINX;
         }
         if (x > this.MAXX) {
            x = this.MAXX;
         }
         this.knobImg.style.left = x + "px";
         this.sliderValue = (x - this.MINX) / (this.MAXX - this.MINX) ;
         if (this.sliderListener != null) {
             (this.sliderListener)(this.getSliderValue());
         }
    }

    SliderControl.prototype.getOffset = function (event, parentElem) {
        if (!event) {
            // IE
            event = window.event;
        }

        // reference from prototype.js
        var x = event.pageX || (event.clientX +
          (document.documentElement.scrollLeft || document.body.scrollLeft));
        var y = event.pageY || (event.clientY +
          (document.documentElement.scrollTop || document.body.scrollTop));

        var offset = this.getOffsetOfElement(parentElem);

        x = x - offset.x;
        y = y - offset.y;
        return {x:x,y:y};
    }


    SliderControl.prototype.getOffsetOfElement = function (element) {
        // reference from prototype.js
        var valueT = 0, valueL = 0;
        do {
            valueT += element.offsetTop  || 0;
            valueL += element.offsetLeft || 0;
            element = element.offsetParent;
        } while (element);
        return {x:valueL, y:valueT};
    }

    // Sets the proper CSS for the given button element.
    SliderControl.prototype.setContainerStyle_ = function(button) {
        button.style.color = "#0000cc";
        //button.style.backgroundColor = "white";
        button.style.marginTop = "0px";
        button.style.marginLeft = "5px";
        button.style.marginRight = "5px";
        button.style.marginBottom = "5px";
        button.style.border = "0px";
        button.style.padding = "0px";
        button.style.width = "67px";
        button.style.height = "19px";
        if (navigator.userAgent.toLowerCase().indexOf("msie") != -1) {
            button.style.marginTop = "0px";
            button.style.marginLeft = "10px";
            button.style.marginRight = "10px";
            button.style.marginBottom = "0px";
        }
    }

    /**
     * new SetRadiusControl
     */
    function newSetRadiusControl(map) {
        var cntrl = new MyCustomImgControl(
            "img/gmap_r_on.gif",
            "img/gmap_r_off.gif",
            67,
            19,
            null,
            null);
        cntrl.mode = new SetRadiusMode(map);
        cntrl.setListener(function() {

            if (ModeManager.currentMode
                && ModeManager.currentMode.getModeName() == 
                   cntrl.mode.getModeName()) {
                ModeManager.exitMode();
            } else {
                cntrl.mode.setFromPoint(getLatLng());

                try {
                    cntrl.mode.setToPoint(
                        new google.maps.LatLng(
                        cntrl.mode.fromPoint.lat() - meter2degree(getRadius()),
                        cntrl.mode.fromPoint.lng()));
                } catch (e) {
                    cntrl.mode.setToPoint(
                        new google.maps.LatLng(cntrl.mode.fromPoint.lat(),
                             cntrl.mode.fromPoint.lng()));
                }

                ModeManager.changeMode(cntrl.mode);
            }
        });
        cntrl.initialize(map);
        return cntrl;
    }

    /**
     *  convert meter to radian
     */
    function meter2degree(meter) {
        if (isNaN(meter)) {
            throw "meter2degree:" + meter + " is not number";
        }
        return 360.0 * meter / (40000.0 * 1000.0);
    }

    /**
     * return a distance between two point as meter
     */
    function distanceBetween(
        /* google.maps.LatLng */ from,
        /* google.maps.LatLng */ to
    ) {
       try {
           var gfrom = new gmapv3.LatLon(from.lat(), from.lng());
           var gto = new gmapv3.LatLon(to.lat(), to.lng());
           return gfrom.distanceTo(gto) * 1000; // fix the unit from km to m
       } catch (e) {
           console.error("distanceBetween:" + e);
       }
    }

    /**
     * create circle shaped polygon that represents radius
     */
    function getRadiusAreaPolygon(fromPoint, toPoint) {
       var meter = 0;
       try {
           meter = distanceBetween(fromPoint, toPoint);
       } catch (e) {
           console.error("getRadiusAreaPolygon:1:" + e);
       }
       return new google.maps.Circle(
           {center:fromPoint, 
            radius:meter, 
            strokeColor:"#FF0000",
            strokeWeight:1,
            strokeOpacity:0.5,
            fillColor:"#FF0000",
            fillOpacity:0.5});
    }
    /**
     * SetRadiusMode
     */
    function SetRadiusMode(map) {
        this.map = map;
    }
    SetRadiusMode.prototype = new Mode();
    SetRadiusMode.prototype.modeName = "SetRadiusMode";
    SetRadiusMode.prototype.fromPoint = null;
    SetRadiusMode.prototype.toPoint = null;
    SetRadiusMode.prototype.setFromPoint = function(fromPoint) {
        this.fromPoint = fromPoint;
    }
    SetRadiusMode.prototype.setToPoint = function(toPoint) {
        this.toPoint = toPoint;
    }
    // for IE
    SetRadiusMode.prototype.getRadiusAreaPolygon = getRadiusAreaPolygon;
    SetRadiusMode.prototype.setUp = function() {
        if ( (! this.fromPoint) || (! this.toPoint))  {
            return;
        }

        this.addOverlay("fromMarker", 
            new google.maps.Marker({position:this.fromPoint}));
        this.addOverlay("toMarker", 
            new google.maps.Marker({position:this.toPoint,draggable: true}));

        this.addOverlay("radiusLine",
                getRadiusAreaPolygon(
                    this.fromPoint,
                    this.toPoint));

        this.setMyRadius = function() {
            setRadius(distanceBetween(
                this.getOverlay("fromMarker").getPosition(),
                this.getOverlay("toMarker").getPosition()));
         }

        this.drawRadiusLine = function() {
            try {
                this.removeOverlay("radiusLine");
                this.addOverlay("radiusLine",
                    this.getRadiusAreaPolygon(
                        this.getOverlay("fromMarker").getPosition(),
                        this.getOverlay("toMarker").getPosition()));
             } catch (e) {
                console.error("SetRadiusMode.setUp3:" + e);
                showProperty(e);
            }
        }

        var self = this;
        this.addListener(google.maps.event.addListener(
            this.getOverlay("toMarker"), "drag",
                function(){self.setMyRadius();}));
        this.addListener(google.maps.event.addListener(
            this.getOverlay("toMarker"), "dragend",
                function(){self.setMyRadius();self.drawRadiusLine();}));
    }

    /**
     * new SetMBRControl
     */
    function newSetMBRControl(map) {
        var cntrl = new MyCustomImgControl(
            "img/gmap_mbr_on.gif",
            "img/gmap_mbr_off.gif",
            67,
            19,
            null,
            null);

        cntrl.mode = new SetMBRMode(map);
        cntrl.setListener(function() {
            if (ModeManager.currentMode
                && ModeManager.currentMode.getModeName() == 
                   cntrl.mode.getModeName()) {
                ModeManager.exitMode();
            } else {
                try {
                    cntrl.mode.setMbrPoints(getMBR());
                } catch (e) {
                    cntrl.mode.setMbrPoints([getLatLng(), getLatLng()]);
                }
                try {
                    cntrl.mode.setImageUrl(getImageUrl());
                } catch (e) {
                    // there's a case that no definition of getImageUrl
                }
                ModeManager.changeMode(cntrl.mode);
            }
        });
        var slider = new SliderControl(0.5);
        slider.setSliderListener(function(value) {
            if (cntrl.mode.imgOverlay) {
                cntrl.mode.imgOverlay.setOpacity(value);
            }
        });
        cntrl.mode.setSlider(slider);
        cntrl.mode.setSliderHandler(function() {
            if (this.imgOverlay) {
                this.imgOverlay.setOpacity(this.slider.getSliderValue());
            }
        });
        var container = cntrl.initialize(map);
        container.style.marginBottom='0px';
        if (navigator.userAgent.toLowerCase().indexOf("msie") != -1) {
            container.style.marginBottom='-6px';
        }

        slider.initialize(map);
        return cntrl;
    }

    // ImageRect overlay
    // see http://www.google.com/apis/maps/documentation/reference.html#google.maps.OverlayView
    function ImageRect(bounds, imgurl, opt_opacity) {
        this.bounds_ = bounds;
        this.imgurl_ = imgurl;
        this.opacity_ = opt_opacity || "0.5";
    }
    ImageRect.prototype = new google.maps.OverlayView();

    // Creates the DIV representing this rectangle.
    ImageRect.prototype.onAdd = function() {
        var div = null;

        // Create the DIV representing our rectangle
        div = document.createElement("div");
        div["id"] = "rect_overlay";
        div.style.border = "0px";
        div.style.position = "absolute";

        img = document.createElement("img");
        img["src"] = this.imgurl_;
        div.appendChild(img);

        // Our rectangle is flat against the map, so we add our selves to the
        // MAP_PANE pane, which is at the same z-index as the map itself (i.e.,
        // below the marker shadows)

        this.img_ = img;
        this.map_ = map;
        this.div_ = div;
        this.setOpacity(this.opacity_);     
        var panes = this.getPanes();
        panes.overlayLayer.appendChild(div);
    }

    // set opacity
    ImageRect.prototype.setOpacity = function(value) {

        if (value) {
            this.opacity_ = value;
        }

        if (this.div_) {
            // for IE
            this.div_.style.filter = 
                "Alpha(opacity=" + parseInt(this.opacity_ * 100) + ")";
            // for NN,FireFox
            this.div_.style.MozOpacity = this.opacity_;
            // for opera
            this.div_.style.opacity = this.opacity_;
        }
   }

    // Remove the main DIV from the map pane
    ImageRect.prototype.onRemove = function() {
        this.div_.parentNode.removeChild(this.div_);
    }

    // Copy our data to a new ImageRect
    ImageRect.prototype.copy = function() {
        return new ImageRect(this.bounds_, this.imgurl_, this.opacity_);
    }

    // Redraw the rectangle based on the current projection and zoom level
    ImageRect.prototype.draw = function() {

        // Calculate the DIV coordinates of two opposite corners of our 
        // bounds to get the size and position of our rectangle

        var overlayProjection = this.getProjection();
        var c1 = overlayProjection.fromLatLngToDivPixel(
            this.bounds_.getSouthWest());
        var c2 = overlayProjection.fromLatLngToDivPixel(
            this.bounds_.getNorthEast());

        // Now position our DIV based on the DIV coordinates of our bounds
        this.div_.style.width = Math.abs(c2.x - c1.x) + "px";
        this.div_.style.height = Math.abs(c2.y - c1.y) + "px";
        this.div_.style.left = Math.min(c2.x, c1.x) + "px";
        this.div_.style.top = Math.min(c2.y, c1.y) + "px";

        this.img_.style.width = this.div_.style.width;
        this.img_.style.height = this.div_.style.height;
    }

    /**
     * SetMBRMode
     */
    function SetMBRMode(map) {
        this.map = map;
    }
    SetMBRMode.prototype = new Mode();
    SetMBRMode.prototype.modeName = "SetMBRMode";
    SetMBRMode.prototype.mbrPoints = null;
    SetMBRMode.prototype.setMbrPoints = function (mbrPoints) {
        this.mbrPoints = mbrPoints;
    }
    SetMBRMode.prototype.imageUrl = null;
    SetMBRMode.prototype.setImageUrl = function(imageUrl) {
        this.imageUrl = imageUrl;
    }
    SetMBRMode.prototype.imgOverlay = null;
    SetMBRMode.prototype.tearDown = function () {
        for (name in this.overlays) {
            this.overlays[name].setMap(null);
        }
        for (listener in this.listeners) {
            google.maps.event.removeListener(this.listeners[listener]);
        }
        if (this.imgOverlay) {
            this.imgOverlay.setMap(null);
            this.imgOverlay = null;
        }
    }
    SetMBRMode.prototype.sliderHandler = null;
    SetMBRMode.prototype.setSliderHandler = function(handler) {
        this.sliderHandler = handler;
    }
    SetMBRMode.prototype.slider = null;
    SetMBRMode.prototype.setSlider = function(slider) {
        this.slider = slider;
    }
    SetMBRMode.prototype.setUp = function() {
        this.setMyMBR = function() {
            setMBR(
                [this.getOverlay("p1Marker").getPosition(),
                 this.getOverlay("p2Marker").getPosition()]);
            this.mbrPoints[0] = this.getOverlay("p1Marker").getPosition();
            this.mbrPoints[1] = this.getOverlay("p2Marker").getPosition();
        }
        this.showImage = function() {
            if (this.imgOverlay) {
                this.imgOverlay.setMap(null);
            }
            if (! this.imageUrl) {
                return;
            }
            this.imgOverlay = new ImageRect(
                new google.maps.LatLngBounds(
                    new google.maps.LatLng(
                        Math.max(
                            this.mbrPoints[0].lat(),
                            this.mbrPoints[1].lat()),
                        Math.min(
                            this.mbrPoints[0].lng(),
                            this.mbrPoints[1].lng())),
                    new google.maps.LatLng(
                        Math.min(
                            this.mbrPoints[0].lat(),
                            this.mbrPoints[1].lat()),
                        Math.max(
                            this.mbrPoints[0].lng(),
                            this.mbrPoints[1].lng())))
                , this.imageUrl);
            //this.map.addOverlay(this.imgOverlay);
            this.imgOverlay.setMap(this.map);
        }
        this.getMBRPolygon = function() {
            return new google.maps.Polygon(
                {paths:[this.mbrPoints[0],
                     new google.maps.LatLng(
                         this.mbrPoints[0].lat(),this.mbrPoints[1].lng()),
                     this.mbrPoints[1],
                     new google.maps.LatLng(
                         this.mbrPoints[1].lat(), this.mbrPoints[0].lng()),
                     this.mbrPoints[0]],
                 strokeColor:"#FF0000",
                 strokeWeight:1,
                 strokeOpacity:0.5,
                 fillColor:"#FF0000",
                 fillOpacity:0.5});
         }
        this.drawMBRRect = function() {
             this.removeOverlay("mbrPolygon");
             this.addOverlay("mbrPolygon", this.getMBRPolygon());
        }
        this.showMBR = function () {
            if (this.imageUrl && "http://" != this.imageUrl ){
                this.showImage();
            } else {
                this.drawMBRRect();
            }
        }

        this.addOverlay("p1Marker", new google.maps.Marker(
            {position:this.mbrPoints[0],draggable: true}));
        this.addOverlay("p2Marker", new google.maps.Marker(
            {position:this.mbrPoints[1],draggable: true}));
        this.showMBR();

        var self = this;
        this.addListener(google.maps.event.addListener(
            this.getOverlay("p1Marker"), "drag",
                function(){self.setMyMBR();}));
        this.addListener(google.maps.event.addListener(
            this.getOverlay("p1Marker"), "dragend",
                function(){
                    self.setMyMBR();
                    self.showMBR();
                    self.execSliderHandler();
                }));
        this.addListener(google.maps.event.addListener(
            this.getOverlay("p2Marker"), "drag",
                function(){self.setMyMBR();}));
        this.addListener(google.maps.event.addListener(
            this.getOverlay("p2Marker"), "dragend",
                function(){
                    self.setMyMBR();
                    self.showMBR();
                    self.execSliderHandler();
                }));
        this.execSliderHandler = function() {
            try {
                if (self.sliderHandler) {
                    (self.sliderHandler)();
                }
            } catch(e) {
                console.error("self.sliderHandler" + e);
            }
        }

        if (this.sliderHandler) {
            (this.sliderHandler)();
        }
    }

    /**
     * new SetZoomControl
     */
    function newSetZoomControl(map) {
        var cntrl = new MyCustomImgControl(
            "img/gmap_zoom_on.gif",
            "img/gmap_zoom_off.gif",
            67,
            19,
            function() {setZoom(map.getZoom());},
            null);
        cntrl.initialize(map);
        return cntrl;
    }

    /**
     * SetLatLngMode
     */
    function SetLatLngMode(map) {
        this.map = map;
    }
    SetLatLngMode.prototype = new Mode();
    SetLatLngMode.prototype.modeName = "SetLatLngMode";
    SetLatLngMode.prototype.point = null;
    SetLatLngMode.prototype.setPoint = function(point) {
        this.point = point;
    }

    SetLatLngMode.prototype.setUp = function () {
        var self = this;
        try {
          var marker;
          if (this.markerColor !== "" || this.markerUrl !== "" ) {
            var label = "";
            if (this.markerLabel !== "") {
              label = this.markerLabel;
            }
            marker = createGmapMarker({
              point: this.point,
              label: label,
              draggable: true,
              color: this.markerColor,
              imgURL: this.markerUrl,
              map: this.map,
            });
          } else {
            marker = new google.maps.Marker({position: this.point, draggable: true});
          }
          this.addOverlay("currMarker", marker);
        } catch (e) {
            console.error("SetLatLngMode.setUp:" + e);
        }

        this.setCurrLatLng = function () {
            this.setPoint(this.getOverlay("currMarker").getPosition());
            setLatLng(this.point);
        }

        this.addListener(google.maps.event.addListener(
            this.getOverlay("currMarker"), "dragend",
            function(){self.setCurrLatLng();})
        );

        this.addListener(google.maps.event.addListener(
            this.getOverlay("currMarker"), "drag",
            function(){self.setCurrLatLng();})
        );

        this.addListener(google.maps.event.addListener(this.map, "click",
            function(marker, point){
                try {
                    if (point) {
                        self.getOverlay("currMarker").setPoint(point);
                        self.setCurrLatLng();
                    }
                    if (marker) {
                        self.map.panTo(
                            self.getOverlay("currMarker").getPosition());
                    }
                } catch (e) {
                    console.error(e);
                }
            }
        ));
    }

    /**
     * SetLatLngQueryMode
     */
    function SetLatLngQueryMode(map) {
        this.map = map;
    }
    SetLatLngQueryMode.prototype = new Mode();
    SetLatLngQueryMode.prototype.modeName = "SetLatLngQueryMode";
    SetLatLngQueryMode.prototype.llPoints = null;
    SetLatLngQueryMode.prototype.setLatLngPoints = function (llPoints) {
        this.llPoints = llPoints;
    }
    SetLatLngQueryMode.prototype.setUp = function() {
        this.setMyLatLngQuery = function() {
            setLatLngQuery(
                [this.getOverlay("p1Marker").getPosition(),
                 this.getOverlay("p2Marker").getPosition()]);
            this.llPoints[0] = this.getOverlay("p1Marker").getPosition();
            this.llPoints[1] = this.getOverlay("p2Marker").getPosition();
         }
        this.getMBRPolygon = function() {
            return new google.maps.Polygon(
                {paths:[this.llPoints[0],
                    new google.maps.LatLng(this.llPoints[0].lat(),
                        this.llPoints[1].lng()),
                    this.llPoints[1],
                    new google.maps.LatLng(this.llPoints[1].lat(),
                        this.llPoints[0].lng()),
                    this.llPoints[0]], 
                 strokeColor:"#FF0000", 
                 strokeWeight:1, 
                 strokeOpacity:0.5, 
                 fillColor:"#FF0000", 
                 fillOpacity:0.5});
        }
        this.drawMBRRect = function() {
             this.removeOverlay("llPolygon");
             this.addOverlay("llPolygon", this.getMBRPolygon());
        }

        this.addOverlay("p1Marker", new google.maps.Marker(
            {position:this.llPoints[0], draggable: true}));
        this.addOverlay("p2Marker", new google.maps.Marker(
            {position:this.llPoints[1], draggable: true}));
        this.drawMBRRect();

        var self = this;
        this.addListener(google.maps.event.addListener(
            this.getOverlay("p1Marker"), "drag",
                function(){
                    self.setMyLatLngQuery();
                }));
        this.addListener(google.maps.event.addListener(
            this.getOverlay("p1Marker"), "dragend",
                function(){
                    self.setMyLatLngQuery();
                    self.drawMBRRect();
                }));
        this.addListener(google.maps.event.addListener(
            this.getOverlay("p2Marker"), "drag",
                function(){
                    self.setMyLatLngQuery();
                }));
        this.addListener(google.maps.event.addListener(
            this.getOverlay("p2Marker"), "dragend",
                function(){
                    self.setMyLatLngQuery();
                    self.drawMBRRect();
                }));
    }

    /**
     * ShowGeonameMode is default mode in showGeoname page
     *
     */
    function ShowGeonameMode(map) {
        this.map = map;
    }
    ShowGeonameMode.prototype = new Mode();
    ShowGeonameMode.prototype.modeName = "ShowGeonameMode";
    ShowGeonameMode.prototype.geonameList = [];
    /**
     * geoname, as a hash object, has to have following parameters
     * point: google.maps.LatLng object
     * title: string showed in popup
     * formName: name of form
     * sendActionName: used as id of data
     *
     */
    ShowGeonameMode.prototype.addGeoname = function(geoname) {
        //showProperty(geoname);
        this.geonameList = this.geonameList.concat(geoname);
    }
    /**
     * jump a page from specified form
     */
    ShowGeonameMode.prototype.jumpPage = function (formName, sendActionName) {
        try {
            var fms=document.forms[formName];
            var f = null;
            if (fms.SENDACTION && fms.submit)  {
                f = fms;
            } else {
                for (idx = 0; idx < fms.length;idx ++)   {
                    if (fms[idx].SENDACTION && fms[idx].submit) {
                        f = fms[idx];
                        break;
                    }
                }
            }
            f.SENDACTION.name=sendActionName;
            f.submit();
        } catch (e) {
            console.error("jumpPage:" + e);
        }
    }
    ShowGeonameMode.prototype.setUp = function() {
        // set center to decide map type.
        // if not, it fails to execute addOverlay()
        //this.map.setCenter(new google.maps.LatLng(0,0),13);
        this.map.setCenter(new google.maps.LatLng(0,0));
        this.map.setZoom(13);
        var glb = new google.maps.LatLngBounds();
        for (i = 0,l=this.geonameList.length; i<l ;i++) {
            var geoname = this.geonameList[i];
            if (! geoname["point"]) {
                continue;
            }
            glb.extend(geoname["point"]);
            var markerProperties = {
              point: geoname["point"],
              title: geoname["title"],
              color: geoname["color"] || "",
              imgURL: geoname["imgURL"] || "",
              map: this.map,
            }
            var gm = createGmapMarker(markerProperties);
            try {
                this.addOverlay(geoname["geoname"] + i, gm);
            } catch (ze) {
                console.error("exception" + ze);
            }
            gm["formName"] = geoname["formName"];
            gm["sendActionName"] = geoname["sendActionName"];
            var self = this;
            this.addListener(google.maps.event.addListener(gm, "click",
                function(){self.jumpPage(this["formName"], 
                this["sendActionName"]);}));
        }

        if (! glb.isEmpty()) {
            if (this.geonameList.length > 1) {
                this.map.fitBounds(glb);
            } else {
                this.map.setCenter(geoname["point"]);
            }
        } else {
            this.map.setCenter(new google.maps.LatLng(0,0));
            this.map.setZoom(1);
        }
    }


    function newShowRadiusControl(map) {
        var cntrl = new MyCustomImgControl(
            "img/gmap_r_on.gif",
            "img/gmap_r_off.gif",
            67,
            19,
            null,
            null);

        cntrl.mode = new ShowRadiusMode(map);
        cntrl.setListener(function() {
            if (ModeManager.currentMode
                && ModeManager.currentMode.getModeName() == 
                cntrl.mode.getModeName()) {
                ModeManager.exitMode();
            } else {
                ModeManager.changeMode(cntrl.mode);
            }
        });
        cntrl.initialize(map);
        return cntrl;
    }

    function ShowRadiusMode(map) {
        this.map = map;
    }
    ShowRadiusMode.prototype = new Mode();
    ShowRadiusMode.prototype.modeName = "ShowRadiusMode";
    ShowRadiusMode.prototype.fromPoint = null;
    ShowRadiusMode.prototype.radius = null;
    ShowRadiusMode.prototype.setFromPoint = function(fromPoint) {
        this.fromPoint = fromPoint;
    }
    ShowRadiusMode.prototype.setRadius = function(radius) {
        if (isNaN(radius)) {
            throw "SetRadiusMode.setRadius:" + radius +
                " is not a number";
        }
        this.radius = radius;
    }
    ShowRadiusMode.prototype.setUp = function() {
        if ((! this.fromPoint ) || ( ! this.radius)) {
            return;
        }
        this.addOverlay("fromMarker", new google.maps.Marker(
            {position:this.fromPoint}));
        var toPoint = new google.maps.LatLng(
                this.fromPoint.lat() - meter2degree(this.radius),
                this.fromPoint.lng());
        var toMarker = new google.maps.Marker({position:toPoint});
        this.addOverlay("toMarker", toMarker);
        var pg = getRadiusAreaPolygon(this.fromPoint, toPoint);
        this.addOverlay("radiusLine", pg);
    }

    /**
     * create new ShowMBRControl
     */
    function newShowMBRControl(map) {
        var cntrl = new MyCustomImgControl(
            "img/gmap_mbr_on.gif",
            "img/gmap_mbr_off.gif",
            67,
            19,
            null,
            null);
        
        cntrl.mode = new ShowMBRMode(map);
        cntrl.setListener(function() {
            if (ModeManager.currentMode
                && ModeManager.currentMode.getModeName() == 
                cntrl.mode.getModeName()) {
                ModeManager.exitMode();
            } else {
                ModeManager.changeMode(cntrl.mode);
            }
        });

        var slider = new SliderControl(0.5);
        slider.setSliderListener(function(value) {
            if (cntrl.mode.imgOverlay) {
                cntrl.mode.imgOverlay.setOpacity(value);
            }
        });
        cntrl.mode.setSlider(slider);
        cntrl.mode.setSliderHandler(function() {
            if (this.imgOverlay) {
                this.imgOverlay.setOpacity(
                    this.slider.getSliderValue());
            }
        });
        var container = cntrl.initialize(map);
        container.style.marginBottom='0px';
        if (navigator.userAgent.toLowerCase().indexOf("msie") != -1) {
            container.style.marginBottom='-6px';
        }
        slider.initialize(map);
        return cntrl;
    }


    /**
     * ShowMBRMode
     */
    function ShowMBRMode(map) {
        this.map = map;
    }
    ShowMBRMode.prototype = new Mode();
    ShowMBRMode.prototype.modeName = "ShowMBRMode";
    ShowMBRMode.prototype.mbrPoints = null;
    ShowMBRMode.prototype.setMbrPoints = function (mbrPoints) {
        this.mbrPoints = mbrPoints;
    }
    ShowMBRMode.prototype.imageUrl = null;
    ShowMBRMode.prototype.setImageUrl = function(imageUrl) {
        this.imageUrl = imageUrl;
    }
    ShowMBRMode.prototype.imgOverlay = null;
    ShowMBRMode.prototype.tearDown = function () {
        for (name in this.overlays) {
            this.overlays[name].setMap(null);
        }
        for (listener in this.listeners) {
            google.maps.event.removeListener(this.listeners[listener]);
        }
        if (this.imgOverlay) {
            this.imgOverlay.setMap(null);
            this.imgOverlay = null;
        }
    }
    ShowMBRMode.prototype.sliderHandler = null;
    ShowMBRMode.prototype.setSliderHandler = function(handler) {
        this.sliderHandler = handler;
    }
    ShowMBRMode.prototype.slider = null;
    ShowMBRMode.prototype.setSlider = function(slider) {
        this.slider = slider;
    }

    /**
     *
     */
    ShowMBRMode.prototype.setUp = function() {

        if ((! this.mbrPoints)
            || this.mbrPoints.length != 2
            || (! this.mbrPoints[0])
            || (! this.mbrPoints[1])
            ) {
            return;
        }

        if (this.imageUrl  && "http://" != this.imageUrl) {
            if (this.imgOverlay) {
                this.imgOverlay.setMap(null);
            }

            this.imgOverlay = new ImageRect(
                new google.maps.LatLngBounds(
                    new google.maps.LatLng(
                        Math.max(
                            this.mbrPoints[0].lat(),
                            this.mbrPoints[1].lat()),
                        Math.min(
                            this.mbrPoints[0].lng(),
                            this.mbrPoints[1].lng())),
                    new google.maps.LatLng(
                        Math.min(
                            this.mbrPoints[0].lat(),
                            this.mbrPoints[1].lat()),
                        Math.max(
                            this.mbrPoints[0].lng(),
                            this.mbrPoints[1].lng())))
                , this.imageUrl);
            try {
                this.imgOverlay.setMap(this.map);
            } catch(e) {
                showProperty("ShowMBRMode.prototype.setUp:", e);
            }
        } else {
            this.addOverlay("mbr",
                new google.maps.Polygon(
                    {paths:[this.mbrPoints[0],
                         new google.maps.LatLng(this.mbrPoints[0].lat(),
                             this.mbrPoints[1].lng()),
                         this.mbrPoints[1],
                         new google.maps.LatLng(this.mbrPoints[1].lat(),
                             this.mbrPoints[0].lng()),
                         this.mbrPoints[0]], 
                     strokeColor:"#FF0000",
                     strokeWeight:1, 
                     strokeOpacity:0.5,
                     fillColor:"#FF0000",
                     fillOpacity:0.5}));
        }
        if (this.sliderHandler) {
            (this.sliderHandler)();
        }
    }

    /**
     * read string  like "(123,123)-(234,234)"
     * and make a list of google.maps.LatLng
     */
    function parseMBR(mbrstr) {

        var elems = mbrstr.match(/[-]?[0-9.]+/g);
        if (elems != null && elems.length == 4) {
            return [new google.maps.LatLng(elems[0],elems[1]),
                    new google.maps.LatLng(elems[2],elems[3])];
        }
        throw "failed to get mbr";
    }

    /**
     * ShowLatLngMode
     */
    function ShowLatLngMode(map) {
        this.map = map;
    }
    ShowLatLngMode.prototype = new Mode();
    ShowLatLngMode.prototype.modeName = "ShowLatLngMode";
    ShowLatLngMode.prototype.point = new google.maps.LatLng(0,0);
    ShowLatLngMode.prototype.zoom = 0;
    ShowLatLngMode.prototype.setPoint = function (point) {
        this.point = point;
    }
    ShowLatLngMode.prototype.setCenter = function () {
        this.map.setCenter(this.point);
        this.map.setZoom(parseInt(this.zoom));
    }
    ShowLatLngMode.prototype.panToCenter = function () {
        this.map.panTo(this.point);
    }
    ShowLatLngMode.prototype.setUp = function() {
        if (! this.point) {
            return;
        }
        var marker;
        if (this.markerColor !== "" || this.markerUrl !== "") {
          marker = createGmapMarker({
            point: this.point,
            color: this.markerColor,
            imgURL: this.markerUrl,
            map: this.map,
          });
        } else {
          marker = new google.maps.Marker({position:this.point});
        }
        this.addOverlay("point", marker);

        var self = this;
        this.addListener(google.maps.event.addListener(this.map, "click",
            function(marker, point){
                try {
                    if (marker) {
                        self.panToCenter();
                    }
                } catch (e) {
                    console.error(e);
                }
            }
        ));
    }


    /**
     * cache element
     *
     */
    function ElementCache(){
    }
    ElementCache.nameCache = {};
    ElementCache.idCache = {};
    ElementCache.getFirstElementByName = function(name) {
        var elem = this.nameCache[name];
        if (elem) {
            return elem;
        }
        elem = getMyFirstElementByName(name);
        if (elem) {
            this.nameCache[name] = elem;
        }
        return elem;
    }
    ElementCache.getElementById = function(id) {
        var elem = this.idCache[id];
        if (elem) {
            return elem;
        }
        elem = getMyElementById(id);
        if (elem) {
            this.idCache[id] = elem;
        }
        return elem;
    }
    ElementCache.fin = function() {
        this.nameCache = null;
        this.idCache = null;
    }
    Initializer.addFin(ElementCache.fin);

    // get value from specifiled element
    // id - id of element which holds value
    function getMyFirstElementByName(name) {
        var tags = null;
        try {
            tags = getMyElementsByName(name);
        } catch (e) {
            console.error(e);
        }

        if (tags && tags.length > 0) {
            return tags[0];
        }

        throw "element named \"" + name + "\" is not found";
    }

    // get elements by specifiled name
    // name - value of element.getAttribute("name")
    function getMyElementsByName(name) {
        var tags = new Array();

        var elem = document;
        var parentStack = new Array();
        while(elem != null || parentStack.length > 0) {

            if (elem.getAttribute
                && elem.getAttribute("name") == name) {
                tags.push(elem);
            }

            // set next element to elem
            if (elem.firstChild) {
                parentStack.push(elem);
                elem = elem.firstChild;
            } else
            if (elem.nextSibling){
                elem = elem.nextSibling;
            } else {
                while (elem && ! elem.nextSibling) {
                    elem = parentStack.pop();
                }
                if (elem) {
                    elem = elem.nextSibling;
                }
            }
        }
        return tags;
    }

    // get value from specifiled element
    // id - id of element which holds value
    function getMyElementById(id) {
        var tag = null;
        if (document.getElementById) {
            tag = document.getElementById(id);
        } else
        if (document.all.getElementById) {
            tag = document.all.getElementById(id);
        }
        return tag;
    }

    // set value into specifiled textareas
    // tagName - name of input tag which holds value
    // value   - value
    function setValue2Tag(tagName,value) {
        //getMyFirstElementByName(tagName).value = value;
        ElementCache.getFirstElementByName(tagName).value = value;
    }

    // get value from specifiled textareas
    // tagName - name of input tag which holds value
    function getValueFrom(name) {
        var value = getValueFromElement(ElementCache.getFirstElementByName(name));
        require(["dojo/string"], function(string) {
          value = string.trim(value);
        });
        if (value === "&nbsp;") {
          value = "";
        }
        return value;
    }


    // get value from specifiled element
    // id - id of element which holds value
    function getValueFromId(id) {
        //return getValueFromElement(getMyElementById(id));
        var value = getValueFromElement(ElementCache.getElementById(id));
        require(["dojo/string"], function(string) {
          value = string.trim(value);
        });
        if (value === "&nbsp;") {
          value = "";
        }
        return value;
    }

    // get value from specifiled element
    // id - id of element which holds value
    function getValueFromElement(elem) {
        if (elem.tagName.toLowerCase() == "input") {
            return elem.value;
        } else
        if (elem.tagName.toLowerCase() == "div" || 
            elem.tagName.toLowerCase() == "span") {
            return elem.innerHTML;
        }
        throw "unexpected element :type " + elem.tagName;
    }

    /**
     * initialize blur event of element named by name
     *
     * - name:name of element
     * - handler: function to execute
     */
    function initOnblurEvent(name, handler) {
       initElemEvent(name, "onblur", handler);
    }

    /**
     * initialize event of element named by name
     *
     * - name:name of element
     * - evntName:name of element
     * - handler: function to execute
     */
    function initElemEvent(name, evntName, handler) {
       var tag = null;
       try {
           tag = getMyFirstElementByName(name);
       } catch(e) {
       }
       if (!tag) {
           tag = getMyElementById(name);
       }
       if (tag) {
           tag[evntName] = handler;
       }
       if (name == "fire_geocoding") {
           tag = dijit.byId(name);
           tag[evntName] = handler;
       }
    }


    function showProperty() {
        var s = null;
        var obj = null;
        if (showProperty.arguments.length == 1)  {
            s = "showProperty:\n";
            obj = showProperty.arguments[0];
        } else
        if (showProperty.arguments.length == 2)  {
            s = showProperty.arguments[0] + ":\n";
            obj = showProperty.arguments[1]
        }
        i = 0;
        for (var e in obj) {
            s = s + e + ":" + obj[e] + " ";
//            s = s + "\n";
            i ++;
            if (i % 20 == 0) {
                s = s + "\n";
            }
        }
        console.info(s);
    }

    function createGmapMarkers(points) {
      if (!points || points.length === 0) {
        return null;
      }
      var markers = [];
      var previousPoint = null;
      for (var i=0,l=points.length; i<l; i++) {
        if (i > 0) {
          previousPoint = points[i - 1].point;
        }
        var marker = createGmapMarker({
          point: points[i].point,
          group: points[i].group,
          label: points[i].label,
          color: points[i].color,
          imgURL: points[i].imgURL,
          visible: points[i].visible,
          draggable: points[i].draggable,
          map: points[i].map,
          previousPoint: previousPoint,
        });
        markers.push(marker);
        setLatLngWidgetMarkerEvent(points[i], marker);
      }
      return markers;
    }

    function getNewMarkerPosition(args) {
      var point = args.point;
      if (point.lat === "") {
        if (args.previousPoint) {
          point.lat = args.previousPoint.lat;
        } else {
          point.lat = args.map.getCenter().lat();
        }
      }
      if (point.lng === "") {
        if (args.previousPoint) {
          point.lng = args.previousPoint.lng;
        } else {
          point.lng = args.map.getCenter().lng();
        }
      }
      return point;
    }

    function createGmapMarker(args) {
      var isNewPoint = false;
      var point = args.point;
      if (point.lat === "" && point.lng === "") {
        point = getNewMarkerPosition(args);
        args.map.panTo(point);
        isNewPoint = true;
      }
      var draggable = false;
      if (args.draggable) {
        draggable = args.draggable;
      }
      var visible = true;
      if (args.visible !== undefined) {
        visible = args.visible;
      }
      var properties = {
        position: point,
        draggable: draggable,
        visible: visible,
        map: args.map,
      }
      if (args.title) {
        properties["title"] = args.title;
      }
      var showLabelDelayTime = 200;
      if (isNewPoint) {
        properties["animation"] = google.maps.Animation.DROP;
        showLabelDelayTime = 600;
      }
      if (args.imgURL && args.imgURL !== "") {
        properties["icon"] = {
          url: args.imgURL,
          labelOrigin: {x: 15, y: 11},
        };
      } else if (args.color && args.color !== "") {
        properties["icon"] = {
          path: 'M -10 -23 A 11 11, 0, -2, 1, 10 -23 Q 1 -10 0 0 Q -1 -10 -10 -23 Z',
          fillColor: args.color,
          fillOpacity: 0.8,
          scale: 1,
          strokeColor: '#333333',
          strokeWeight: 1,
          labelOrigin: {x: 0, y: -26},
        };
      }
      var marker = new google.maps.Marker(properties);
      if (args.label) {
        setTimeout(function() {
          marker.setLabel({
            text: args.label,
            fontWeight: 'bold',
            fontSize: '18px',
          });
        }, showLabelDelayTime);
      }
      return marker;
    }

  function setPolylineMarkerEvent(pl, points, markers) {
    pl.binder = new MVCArrayBinder(pl.getPath());
    for (var i=0,l=markers.length; i<l; i++) {
      markers[i].bindTo('position', pl.binder, i.toString());
    }
    var infowindow = new google.maps.InfoWindow();
    pl.addListener('click', function(event) {
      showDistance(event, pl, points, infowindow);
    });
    var map = points[0].map;
    map.addListener('click', function(event) {
      infowindow.close();
    });
  }

  function showDistance(event, pl, points, infowindow) {
    var path = pl.getPath();
    var pathPoints = path.b;
    var map = points[0].map;
    var distance = google.maps.geometry.spherical.computeLength(pathPoints);
    var area;
    if (pathPoints[0].lat() === pathPoints[pathPoints.length - 1].lat() &&
        pathPoints[0].lng() === pathPoints[pathPoints.length - 1].lng()) {
      area = google.maps.geometry.spherical.computeArea(pathPoints);
    }
    infowindow.setPosition(event.latLng);
    infowindow.setContent(getDistanceContent(distance, area));
    infowindow.open(map, pl);
  }

  function getDistanceContent(distance, area) {
    var unit = "m";
    if (distance > 1000) {
      unit = "km";
      distance = distance / 1000;
    }
    var content = '<div>' + res.LABEL_TOTAL_DISTANCE + ':' + distance.toFixed(2) + ' ' + unit + '</div>';
    if (area) {
      unit = res.LABEL_SQUARE_METER;
      if (area > 1000000) {
        unit = res.LABEL_SQUARE_KILOMETER;
        area = area / 1000000;
      }
      content = content + '<div>' + res.LABEL_TOTAL_AREA + ':' + area.toFixed(2) + ' ' + unit + '</div>';
    }
    return content;
  }

  function setLatLngWidgetMarkerEvent(point, marker) {
    if (!point.latLngInput || !point.latLngInput.lat || !point.latLngInput.lng) {
      return;
    }
    var latWidget = getWidget(point.latLngInput.lat);
    var lngWidget = getWidget(point.latLngInput.lng);
    if (!latWidget || !lngWidget) {
      return;
    }
    latWidget.on('change', function() {
    });
    lngWidget.on('change', function() {
    });
    marker.addListener('dragend', function(event) {
      latWidget.set("value", event.latLng.lat());
      lngWidget.set("value", event.latLng.lng());
    });
  }

  function getGmapMarkerVisible(id) {
    var element = ElementCache.getElementById(id)
    if (!element) {
      return false;
    }
    var value = getValueFromId(id);
    if (value === "1") {
      return true;
    }
    return false;
  }

  function getWidget(id) {
    var widget;
    require(["dijit/registry"], function(registry) {
      widget = registry.byId(id);
    });
    return widget;
  }

  function getPointsByGroup(points) {
    var pointsByGroup = {};
	for (var i=0,l=points.length; i<l; i++) {
      var point = points[i];
      if (!pointsByGroup[point.group]) {
        pointsByGroup[point.group] = [];
      }
      (pointsByGroup[point.group]).push(point);
    }
    return pointsByGroup;
  }

  function drawGmapPolylines(map) {
    var points = getGmapPoints(map);
    if (points.length < 2) {
      var markers = createGmapMarkers(points);
      return;
    }
    var pointsByGroup = getPointsByGroup(points)
    for (var key in pointsByGroup) {
      drawGmapPolyline(pointsByGroup[key], map);
    }
  }

  function drawGmapPolyline(points, map) {
    var markers = createGmapMarkers(points);
    var path = [];
	for (var i=0,l=points.length; i<l; i++) {
      path.push(points[i].point);
    }
    var pl = new google.maps.Polyline({
      path: path,
      strokeWeight: 4,
    });
    setPolylineMarkerEvent(pl, points, markers);
    pl.setMap(map);
  }

  function createColorPalleteWidget(modelId, markerColorWidgetId) {
    require(["dijit/ColorPalette", "dijit/TooltipDialog", "dijit/registry", "dijit/popup", "dojo/on", "dojo/dom", "dojo/dom-construct"], function(ColorPalette, TooltipDialog, registry, popup, on, dom, domConstruct) {
      var colorPaletteDialog = new TooltipDialog({
        id: "jfcColorPaletteDialog",
        style: "width: 230px",
      });
      var colorPalette = new ColorPalette({
        palette: "7x10",
        onChange: function(value) {
          if (this.colorWidget) {
            this.colorWidget.set("value", value);
          }
        },
      }, colorPaletteDialog.contentsNode);
      var setColorWidgetEvent = function(colorWidget) {
        on(colorWidget, "focus", function() {
          colorPalette.colorWidget = colorWidget;
          popup.open({
            popup: colorPaletteDialog,
            around: colorWidget.domNode,
          });
        });
        on(colorWidget, "blur", function() {
          // blur イベントで直ぐに TooltipDialog を閉じると ColorPalette から
          // 色が取得できなくなるため、150ms 遅らせる
          setTimeout(function() {
            popup.close(colorPaletteDialog);
          }, 150);
        });
      }
      if (markerColorWidgetId) {
        var centerMakerColorWidget = registry.byId(markerColorWidgetId);
        if (centerMakerColorWidget) {
          setColorWidgetEvent(centerMakerColorWidget);
        }
      }
      for (var i=1;;i++) {
        var colorWidget = registry.byId(modelId + "_002fjfcMapPoints_005b" + i + "_005d_002fjfcPointColor");
        if (!colorWidget) {
          break;
        }
        setColorWidgetEvent(colorWidget);
      }
    });
  }

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  */
/*  Latitude/longitude spherical geodesy formulae & scripts (c) Chris Veness 2002-2010            */
/*   - www.movable-type.co.uk/scripts/latlong.html                                                */
/*                                                                                                */
/*  Sample usage:                                                                                 */
/*    var p1 = new gmapv3.LatLon(51.5136, -0.0983);                                                      */
/*    var p2 = new gmapv3.LatLon(51.4778, -0.0015);                                                      */
/*    var dist = p1.distanceTo(p2);          // in km                                             */
/*    var brng = p1.bearingTo(p2);           // in degrees clockwise from north                   */
/*    ... etc                                                                                     */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  */

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  */
/*  Note that minimal error checking is performed in this example code!                           */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  */

/* namespace for following code */
var gmapv3 = {};

/**
 * Creates a point on the earth's surface at the supplied latitude / longitude
 *
 * @constructor
 * @param {Number} lat: latitude in numeric degrees
 * @param {Number} lon: longitude in numeric degrees
 * @param {Number} [rad=6371]: radius of earth if different value is required from standard 6,371km
 */
gmapv3.LatLon = function(lat, lon, rad) {
  if (typeof rad == 'undefined') rad = 6371;  // earth's mean radius in km
  this._lat = lat;
  this._lon = lon;
  this._radius = rad;
}


/**
 * Returns the distance from this point to the supplied point, in km 
 * (using Haversine formula)
 *
 * from: Haversine formula - R. W. Sinnott, "Virtues of the Haversine",
 *       Sky and Telescope, vol 68, no 2, 1984
 *
 * @param   {LatLon} point: Latitude/longitude of destination point
 * @param   {Number} [precision=4]: no of significant digits to use for returned value
 * @returns {Number} Distance in km between this point and destination point
 */
gmapv3.LatLon.prototype.distanceTo = function(point, precision) {
  // default 4 sig figs reflects typical 0.3% accuracy of spherical model
  if (typeof precision == 'undefined') precision = 4;  
  
  var R = this._radius;
  var lat1 = this._lat.toRad(), lon1 = this._lon.toRad();
  var lat2 = point._lat.toRad(), lon2 = point._lon.toRad();
  var dLat = lat2 - lat1;
  var dLon = lon2 - lon1;

  var a = Math.sin(dLat/2) * Math.sin(dLat/2) +
          Math.cos(lat1) * Math.cos(lat2) * 
          Math.sin(dLon/2) * Math.sin(dLon/2);
  var c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1-a));
  var d = R * c;
  return d.toPrecisionFixed(precision);
}


/**
 * Returns the (initial) bearing from this point to the supplied point, in degrees
 *   see http://williams.best.vwh.net/avform.htm#Crs
 *
 * @param   {LatLon} point: Latitude/longitude of destination point
 * @returns {Number} Initial bearing in degrees from North
 */
gmapv3.LatLon.prototype.bearingTo = function(point) {
  var lat1 = this._lat.toRad(), lat2 = point._lat.toRad();
  var dLon = (point._lon-this._lon).toRad();

  var y = Math.sin(dLon) * Math.cos(lat2);
  var x = Math.cos(lat1)*Math.sin(lat2) -
          Math.sin(lat1)*Math.cos(lat2)*Math.cos(dLon);
  var brng = Math.atan2(y, x);
  
  return (brng.toDeg()+360) % 360;
}


/**
 * Returns final bearing arriving at supplied destination point from this point; the final bearing 
 * will differ from the initial bearing by varying degrees according to distance and latitude
 *
 * @param   {LatLon} point: Latitude/longitude of destination point
 * @returns {Number} Final bearing in degrees from North
 */
gmapv3.LatLon.prototype.finalBearingTo = function(point) {
  // get initial bearing from supplied point back to this point...
  var lat1 = point._lat.toRad(), lat2 = this._lat.toRad();
  var dLon = (this._lon-point._lon).toRad();

  var y = Math.sin(dLon) * Math.cos(lat2);
  var x = Math.cos(lat1)*Math.sin(lat2) -
          Math.sin(lat1)*Math.cos(lat2)*Math.cos(dLon);
  var brng = Math.atan2(y, x);
          
  // ... & reverse it by adding 180°
  return (brng.toDeg()+180) % 360;
}


/**
 * Returns the midpoint between this point and the supplied point.
 *   see http://mathforum.org/library/drmath/view/51822.html for derivation
 *
 * @param   {LatLon} point: Latitude/longitude of destination point
 * @returns {LatLon} Midpoint between this point and the supplied point
 */
gmapv3.LatLon.prototype.midpointTo = function(point) {
  lat1 = this._lat.toRad(), lon1 = this._lon.toRad();
  lat2 = point._lat.toRad();
  var dLon = (point._lon-this._lon).toRad();

  var Bx = Math.cos(lat2) * Math.cos(dLon);
  var By = Math.cos(lat2) * Math.sin(dLon);

  lat3 = Math.atan2(Math.sin(lat1)+Math.sin(lat2),
                    Math.sqrt( (Math.cos(lat1)+Bx)*(Math.cos(lat1)+Bx) + By*By) );
  lon3 = lon1 + Math.atan2(By, Math.cos(lat1) + Bx);

  return new gmapv3.LatLon(lat3.toDeg(), lon3.toDeg());
}


/**
 * Returns the destination point from this point having travelled the given distance (in km) on the 
 * given initial bearing (bearing may vary before destination is reached)
 *
 *   see http://williams.best.vwh.net/avform.htm#LL
 *
 * @param   {Number} brng: Initial bearing in degrees
 * @param   {Number} dist: Distance in km
 * @returns {LatLon} Destination point
 */
gmapv3.LatLon.prototype.destinationPoint = function(brng, dist) {
  dist = dist/this._radius;  // convert dist to angular distance in radians
  brng = brng.toRad();  // 
  var lat1 = this._lat.toRad(), lon1 = this._lon.toRad();

  var lat2 = Math.asin( Math.sin(lat1)*Math.cos(dist) + 
                        Math.cos(lat1)*Math.sin(dist)*Math.cos(brng) );
  var lon2 = lon1 + Math.atan2(Math.sin(brng)*Math.sin(dist)*Math.cos(lat1), 
                               Math.cos(dist)-Math.sin(lat1)*Math.sin(lat2));
  lon2 = (lon2+3*Math.PI)%(2*Math.PI) - Math.PI;  // normalise to -180...+180

  if (isNaN(lat2) || isNaN(lon2)) return null;
  return new gmapv3.LatLon(lat2.toDeg(), lon2.toDeg());
}


/**
 * Returns the point of intersection of two paths defined by point and bearing
 *
 *   see http://williams.best.vwh.net/avform.htm#Intersection
 *
 * @param   {LatLon} p1: First point
 * @param   {Number} brng1: Initial bearing from first point
 * @param   {LatLon} p2: Second point
 * @param   {Number} brng2: Initial bearing from second point
 * @returns {LatLon} Destination point (null if no unique intersection defined)
 */
gmapv3.LatLon.intersection = function(p1, brng1, p2, brng2) {
  lat1 = p1._lat.toRad(), lon1 = p1._lon.toRad();
  lat2 = p2._lat.toRad(), lon2 = p2._lon.toRad();
  brng13 = brng1.toRad(), brng23 = brng2.toRad();
  dLat = lat2-lat1, dLon = lon2-lon1;
  
  dist12 = 2*Math.asin( Math.sqrt( Math.sin(dLat/2)*Math.sin(dLat/2) + 
    Math.cos(lat1)*Math.cos(lat2)*Math.sin(dLon/2)*Math.sin(dLon/2) ) );
  if (dist12 == 0) return null;
  
  // initial/final bearings between points
  brngA = Math.acos( ( Math.sin(lat2) - Math.sin(lat1)*Math.cos(dist12) ) / 
    ( Math.sin(dist12)*Math.cos(lat1) ) );
  if (isNaN(brngA)) brngA = 0;  // protect against rounding
  brngB = Math.acos( ( Math.sin(lat1) - Math.sin(lat2)*Math.cos(dist12) ) / 
    ( Math.sin(dist12)*Math.cos(lat2) ) );
  
  if (Math.sin(lon2-lon1) > 0) {
    brng12 = brngA;
    brng21 = 2*Math.PI - brngB;
  } else {
    brng12 = 2*Math.PI - brngA;
    brng21 = brngB;
  }
  
  alpha1 = (brng13 - brng12 + Math.PI) % (2*Math.PI) - Math.PI;  // angle 2-1-3
  alpha2 = (brng21 - brng23 + Math.PI) % (2*Math.PI) - Math.PI;  // angle 1-2-3
  
  if (Math.sin(alpha1)==0 && Math.sin(alpha2)==0) return null;  // infinite intersections
  if (Math.sin(alpha1)*Math.sin(alpha2) < 0) return null;       // ambiguous intersection
  
  //alpha1 = Math.abs(alpha1);
  //alpha2 = Math.abs(alpha2);
  // ... Ed Williams takes abs of alpha1/alpha2, but seems to break calculation?
  
  alpha3 = Math.acos( -Math.cos(alpha1)*Math.cos(alpha2) + 
                       Math.sin(alpha1)*Math.sin(alpha2)*Math.cos(dist12) );
  dist13 = Math.atan2( Math.sin(dist12)*Math.sin(alpha1)*Math.sin(alpha2), 
                       Math.cos(alpha2)+Math.cos(alpha1)*Math.cos(alpha3) )
  lat3 = Math.asin( Math.sin(lat1)*Math.cos(dist13) + 
                    Math.cos(lat1)*Math.sin(dist13)*Math.cos(brng13) );
  dLon13 = Math.atan2( Math.sin(brng13)*Math.sin(dist13)*Math.cos(lat1), 
                       Math.cos(dist13)-Math.sin(lat1)*Math.sin(lat3) );
  lon3 = lon1+dLon13;
  lon3 = (lon3+Math.PI) % (2*Math.PI) - Math.PI;  // normalise to -180..180º
  
  return new gmapv3.LatLon(lat3.toDeg(), lon3.toDeg());
}


/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  */

/**
 * Returns the distance from this point to the supplied point, in km, travelling along a rhumb line
 *
 *   see http://williams.best.vwh.net/avform.htm#Rhumb
 *
 * @param   {LatLon} point: Latitude/longitude of destination point
 * @returns {Number} Distance in km between this point and destination point
 */
gmapv3.LatLon.prototype.rhumbDistanceTo = function(point) {
  var R = this._radius;
  var lat1 = this._lat.toRad(), lat2 = point._lat.toRad();
  var dLat = (point._lat-this._lat).toRad();
  var dLon = Math.abs(point._lon-this._lon).toRad();
  
  var dPhi = Math.log(Math.tan(lat2/2+Math.PI/4)/Math.tan(lat1/2+Math.PI/4));
  var q = (!isNaN(dLat/dPhi)) ? dLat/dPhi : Math.cos(lat1);  // E-W line gives dPhi=0
  // if dLon over 180° take shorter rhumb across 180° meridian:
  if (dLon > Math.PI) dLon = 2*Math.PI - dLon;
  var dist = Math.sqrt(dLat*dLat + q*q*dLon*dLon) * R; 
  
  return dist.toPrecisionFixed(4);  // 4 sig figs reflects typical 0.3% accuracy of spherical model
}

/**
 * Returns the bearing from this point to the supplied point along a rhumb line, in degrees
 *
 * @param   {LatLon} point: Latitude/longitude of destination point
 * @returns {Number} Bearing in degrees from North
 */
gmapv3.LatLon.prototype.rhumbBearingTo = function(point) {
  var lat1 = this._lat.toRad(), lat2 = point._lat.toRad();
  var dLon = (point._lon-this._lon).toRad();
  
  var dPhi = Math.log(Math.tan(lat2/2+Math.PI/4)/Math.tan(lat1/2+Math.PI/4));
  if (Math.abs(dLon) > Math.PI) dLon = dLon>0 ? -(2*Math.PI-dLon) : (2*Math.PI+dLon);
  var brng = Math.atan2(dLon, dPhi);
  
  return (brng.toDeg()+360) % 360;
}

/**
 * Returns the destination point from this point having travelled the given distance (in km) on the 
 * given bearing along a rhumb line
 *
 * @param   {Number} brng: Bearing in degrees from North
 * @param   {Number} dist: Distance in km
 * @returns {LatLon} Destination point
 */
gmapv3.LatLon.prototype.rhumbDestinationPoint = function(brng, dist) {
  var R = this._radius;
  var d = parseFloat(dist)/R;  // d = angular distance covered on earth's surface
  var lat1 = this._lat.toRad(), lon1 = this._lon.toRad();
  brng = brng.toRad();

  var lat2 = lat1 + d*Math.cos(brng);
  var dLat = lat2-lat1;
  var dPhi = Math.log(Math.tan(lat2/2+Math.PI/4)/Math.tan(lat1/2+Math.PI/4));
  var q = (!isNaN(dLat/dPhi)) ? dLat/dPhi : Math.cos(lat1);  // E-W line gives dPhi=0
  var dLon = d*Math.sin(brng)/q;
  // check for some daft bugger going past the pole
  if (Math.abs(lat2) > Math.PI/2) lat2 = lat2>0 ? Math.PI-lat2 : -(Math.PI-lat2);
  lon2 = (lon1+dLon+3*Math.PI)%(2*Math.PI) - Math.PI;
 
  return new gmapv3.LatLon(lat2.toDeg(), lon2.toDeg());
}

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  */


/**
 * Returns the latitude of this point; signed numeric degrees if no format, otherwise format & dp 
 * as per Geo.toLat()
 *
 * @param   {String} [format]: Return value as 'd', 'dm', 'dms'
 * @param   {Number} [dp=0|2|4]: No of decimal places to display
 * @returns {Number|String} Numeric degrees if no format specified, otherwise deg/min/sec
 *
 * @requires Geo
 */
gmapv3.LatLon.prototype.lat = function(format, dp) {
  if (typeof format == 'undefined') return this._lat;
  
  return gmapv3.Geo.toLat(this._lat, format, dp);
}

/**
 * Returns the longitude of this point; signed numeric degrees if no format, otherwise format & dp 
 * as per Geo.toLon()
 *
 * @param   {String} [format]: Return value as 'd', 'dm', 'dms'
 * @param   {Number} [dp=0|2|4]: No of decimal places to display
 * @returns {Number|String} Numeric degrees if no format specified, otherwise deg/min/sec
 *
 * @requires Geo
 */
gmapv3.LatLon.prototype.lon = function(format, dp) {
  if (typeof format == 'undefined') return this._lon;
  
  return gmapv3.Geo.toLon(this._lon, format, dp);
}

/**
 * Returns a string representation of this point; format and dp as per lat()/lon()
 *
 * @param   {String} [format]: Return value as 'd', 'dm', 'dms'
 * @param   {Number} [dp=0|2|4]: No of decimal places to display
 * @returns {String} Comma-separated latitude/longitude
 *
 * @requires Geo
 */
gmapv3.LatLon.prototype.toString = function(format, dp) {
  if (typeof format == 'undefined') format = 'dms';
  
  return gmapv3.Geo.toLat(this._lat, format, dp) + ', ' + gmapv3.Geo.toLon(this._lon, format, dp);
}


/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  */

// extend Number object with methods for converting degrees/radians

/** Convert numeric degrees to radians */
if (typeof(String.prototype.toRad) === "undefined") {
  Number.prototype.toRad = function() {
    return this * Math.PI / 180;
  }
}

/** Convert radians to numeric (signed) degrees */
if (typeof(String.prototype.toDeg) === "undefined") {
  Number.prototype.toDeg = function() {
    return this * 180 / Math.PI;
  }
}

/** 
 * Format the significant digits of a number, using only fixed-point notation (no exponential)
 * 
 * @param   {Number} precision: Number of significant digits to appear in the returned string
 * @returns {String} A string representation of number which contains precision significant digits
 */
if (typeof(Number.prototype.toPrecisionFixed) === "undefined") {
  Number.prototype.toPrecisionFixed = function(precision) {
    var numb = this < 0 ? -this : this;  // can't take log of -ve number...
    var sign = this < 0 ? '-' : '';
    
    if (numb == 0) { n = '0.'; while (precision--) n += '0'; return n };  // can't take log of zero
  
    var scale = Math.ceil(Math.log(numb)*Math.LOG10E);  // no of digits before decimal
    var n = String(Math.round(numb * Math.pow(10, precision-scale)));
    if (scale > 0) {  // add trailing zeros & insert decimal as required
      l = scale - n.length;
      while (l-- > 0) n = n + '0';
      if (scale < n.length) n = n.slice(0,scale) + '.' + n.slice(scale);
    } else {          // prefix decimal and leading zeros if required
      while (scale++ < 0) n = '0' + n;
      n = '0.' + n;
    }
    return sign + n;
  }
}

function MVCArrayBinder(mvcArray) {
  this.array_ = mvcArray;
}
MVCArrayBinder.prototype = new google.maps.MVCObject();
MVCArrayBinder.prototype.get = function(key) {
  if (!isNaN(parseInt(key))) {
    return this.array_.getAt(parseInt(key));
  } else {
    this.array_.get(key);
  }
}
MVCArrayBinder.prototype.set = function(key, val) {
  if (!isNaN(parseInt(key))) {
    this.array_.setAt(parseInt(key), val);
  } else {
    this.array_.set(key, val);
  }
}

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  */
/*  Geodesy representation conversion functions (c) Chris Veness 2002-2010                        */
/*   - www.movable-type.co.uk/scripts/latlong.html                                                */
/*                                                                                                */
/*  Sample usage:                                                                                 */
/*    var lat = Geo.parseDMS(' 51° 28′ 40.12″ N');                                                */
/*    var lon = Geo.parseDMS('000° 00′ 05.31″ W');                                                */
/*    var p1 = new LatLon(lat, lon);                                                              */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  */

gmapv3.Geo = {};  // Geo namespace, representing static class

/**
 * Parses string representing degrees/minutes/seconds into numeric degrees
 *
 * This is very flexible on formats, allowing signed decimal degrees, or deg-min-sec optionally
 * suffixed by compass direction (NSEW). A variety of separators are accepted (eg 3º 37' 09"W) 
 * or fixed-width format without separators (eg 0033709W). Seconds and minutes may be omitted. 
 * (Note minimal validation is done).
 *
 * @param   {String|Number} dmsStr: Degrees or deg/min/sec in variety of formats
 * @returns {Number} Degrees as decimal number
 * @throws  {TypeError} dmsStr is an object, perhaps DOM object without .value?
 */
gmapv3.Geo.parseDMS = function(dmsStr) {
  if (typeof deg == 'object') throw new TypeError('Geo.parseDMS - dmsStr is [DOM?] object');
  
  if (!isNaN(dmsStr)) return Number(dmsStr);  // ... signed decimal degrees without NSEW
  
  // strip off any sign or compass dir'n & split out separate d/m/s
  var dms = String(dmsStr).trim().replace(/^-/,'').replace(/[NSEW]$/i,'').split(/[^0-9.,]+/);
  if (dms[dms.length-1]=='') dms.splice(dms.length-1);  // from trailing symbol
  
  if (dms == '') return NaN;
  
  // and convert to decimal degrees...
  switch (dms.length) {
    case 3:  // interpret 3-part result as d/m/s
      var deg = dms[0]/1 + dms[1]/60 + dms[2]/3600; 
      break;
    case 2:  // interpret 2-part result as d/m
      var deg = dms[0]/1 + dms[1]/60; 
      break;
    case 1:  // just d (possibly decimal) or non-separated dddmmss
      var deg = dms[0];
      // check for fixed-width unseparated format eg 0033709W
      if (/[NS]/i.test(dmsStr)) deg = '0' + deg;  // - normalise N/S to 3-digit degrees
      if (/[0-9]{7}/.test(deg)) deg = deg.slice(0,3)/1 + deg.slice(3,5)/60 + deg.slice(5)/3600; 
      break;
    default:
      return NaN;
  }
  if (/^-|[WS]$/i.test(dmsStr.trim())) deg = -deg; // take '-', west and south as -ve
  return Number(deg);
}

/**
 * Convert decimal degrees to deg/min/sec format
 *  - degree, prime, double-prime symbols are added, but sign is discarded, though no compass
 *    direction is added
 *
 * @private
 * @param   {Number} deg: Degrees
 * @param   {String} [format=dms]: Return value as 'd', 'dm', 'dms'
 * @param   {Number} [dp=0|2|4]: No of decimal places to use - default 0 for dms, 2 for dm, 4 for d
 * @returns {String} deg formatted as deg/min/secs according to specified format
 * @throws  {TypeError} deg is an object, perhaps DOM object without .value?
 */
gmapv3.Geo.toDMS = function(deg, format, dp) {
  if (typeof deg == 'object') throw new TypeError('Geo.toDMS - deg is [DOM?] object');
  if (isNaN(deg)) return '';  // give up here if we can't make a number from deg
  
    // default values
  if (typeof format == 'undefined') format = 'dms';
  if (typeof dp == 'undefined') {
    switch (format) {
      case 'd': dp = 4; break;
      case 'dm': dp = 2; break;
      case 'dms': dp = 0; break;
      default: format = 'dms'; dp = 0;  // be forgiving on invalid format
    }
  }
  
  deg = Math.abs(deg);  // (unsigned result ready for appending compass dir'n)
  
  switch (format) {
    case 'd':
      d = deg.toFixed(dp);     // round degrees
      if (d<100) d = '0' + d;  // pad with leading zeros
      if (d<10) d = '0' + d;
      dms = d + '\u00B0';      // add º symbol
      break;
    case 'dm':
      var min = (deg*60).toFixed(dp);  // convert degrees to minutes & round
      var d = Math.floor(min / 60);    // get component deg/min
      var m = (min % 60).toFixed(dp);  // pad with trailing zeros
      if (d<100) d = '0' + d;          // pad with leading zeros
      if (d<10) d = '0' + d;
      if (m<10) m = '0' + m;
      dms = d + '\u00B0' + m + '\u2032';  // add º, ' symbols
      break;
    case 'dms':
      var sec = (deg*3600).toFixed(dp);  // convert degrees to seconds & round
      var d = Math.floor(sec / 3600);    // get component deg/min/sec
      var m = Math.floor(sec/60) % 60;
      var s = (sec % 60).toFixed(dp);    // pad with trailing zeros
      if (d<100) d = '0' + d;            // pad with leading zeros
      if (d<10) d = '0' + d;
      if (m<10) m = '0' + m;
      if (s<10) s = '0' + s;
      dms = d + '\u00B0' + m + '\u2032' + s + '\u2033';  // add º, ', " symbols
      break;
  }
  
  return dms;
}

/**
 * Convert numeric degrees to deg/min/sec latitude (suffixed with N/S)
 *
 * @param   {Number} deg: Degrees
 * @param   {String} [format=dms]: Return value as 'd', 'dm', 'dms'
 * @param   {Number} [dp=0|2|4]: No of decimal places to use - default 0 for dms, 2 for dm, 4 for d
 * @returns {String} Deg/min/seconds
 */
gmapv3.Geo.toLat = function(deg, format, dp) {
  var lat = gmapv3.Geo.toDMS(deg, format, dp);
  return lat=='' ? '' : lat.slice(1) + (deg<0 ? 'S' : 'N');  // knock off initial '0' for lat!
}

/**
 * Convert numeric degrees to deg/min/sec longitude (suffixed with E/W)
 *
 * @param   {Number} deg: Degrees
 * @param   {String} [format=dms]: Return value as 'd', 'dm', 'dms'
 * @param   {Number} [dp=0|2|4]: No of decimal places to use - default 0 for dms, 2 for dm, 4 for d
 * @returns {String} Deg/min/seconds
 */
gmapv3.Geo.toLon = function(deg, format, dp) {
  var lon = gmapv3.Geo.toDMS(deg, format, dp);
  return lon=='' ? '' : lon + (deg<0 ? 'W' : 'E');
}

/**
 * Convert numeric degrees to deg/min/sec as a bearing (0º..360º)
 *
 * @param   {Number} deg: Degrees
 * @param   {String} [format=dms]: Return value as 'd', 'dm', 'dms'
 * @param   {Number} [dp=0|2|4]: No of decimal places to use - default 0 for dms, 2 for dm, 4 for d
 * @returns {String} Deg/min/seconds
 */
gmapv3.Geo.toBrng = function(deg, format, dp) {
  deg = (Number(deg)+360) % 360;  // normalise -ve values to 180º..360º
  var brng =  gmapv3.Geo.toDMS(deg, format, dp);
  return brng.replace('360', '0');  // just in case rounding took us up to 360º!
}

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  */
